//  (c) Copyright 2019 locha project developers
//  (c) Copyright 2019 @Jaz_B
//  (c) Copyright 2019 @rdymac
//  (c) Copyright 2019 @luisan00
//  License?

#ifndef UX_H_
#define UX_H_

#include "Arduino.h"
#include "SSD1306.h"

#define BT_width 8
#define BT_height 10

#define BAT_width 20
#define BAT_height 9

#define WIFI_width 14
#define WIFI_height 8

const unsigned char BT_bits[] PROGMEM = {
  0x18, 0x28, 0x4A, 0x2C, 0x18, 0x2C, 0x4A, 0x28, 0x18, 0x00,
};
// Batt. >0% && <25%
const unsigned char BAT_bits_0[] PROGMEM = {
  0xFC, 0xFF, 0x0F, 0x04, 0x00, 0x08, 0x07, 0x00, 0x08, 0x07,
  0x00, 0x08, 0x07, 0x00, 0x08, 0x07, 0x00, 0x08, 0x07, 0x00,
  0x08, 0x04, 0x00, 0x08, 0xFC, 0xFF, 0x0F,  // 0%
};
// Batt. >25% && <50%
const unsigned char BAT_bits_25[] PROGMEM = {
  0xFC, 0xFF, 0x0F, 0x04, 0x80, 0x0F, 0x07, 0x80, 0x0F, 0x07,
  0x80, 0x0F, 0x07, 0x80, 0x0F, 0x07, 0x80, 0x0F, 0x07, 0x80,
  0x0F, 0x04, 0x80, 0x0F, 0xFC, 0xFF, 0x0F,  // 25%
};
// Batt. >50% && <75%
const unsigned char BAT_bits_50[] PROGMEM = {
  0xFC, 0xFF, 0x0F, 0x04, 0xF8, 0x0F, 0x07, 0xF8, 0x0F, 0x07,
  0xF8, 0x0F, 0x07, 0xF8, 0x0F, 0x07, 0xF8, 0x0F, 0x07, 0xF8,
  0x0F, 0x04, 0xF8, 0x0F, 0xFC, 0xFF, 0x0F,  // 50%
};
// Batt. >75% && <90%
const unsigned char BAT_bits_75[] PROGMEM = {
  0xFC, 0xFF, 0x0F, 0x84, 0xFF, 0x0F, 0x87, 0xFF, 0x0F, 0x87,
  0xFF, 0x0F, 0x87, 0xFF, 0x0F, 0x87, 0xFF, 0x0F, 0x87, 0xFF,
  0x0F, 0x84, 0xFF, 0x0F, 0xFC, 0xFF, 0x0F,  // 75%
};
// Batt. >90%
const unsigned char BAT_bits_100[] PROGMEM = {
  0xFC, 0xFF, 0x0F, 0xFC, 0xFF, 0x0F, 0xFF, 0xFF, 0x0F, 0xFF,
  0xFF, 0x0F, 0xFF, 0xFF, 0x0F, 0xFF, 0xFF, 0x0F, 0xFF, 0xFF,
  0x0F, 0xFC, 0xFF, 0x0F, 0xFC, 0xFF, 0x0F,  // 100%
};

const unsigned char WIFI_bits[] PROGMEM = {
  0xF0, 0x03, 0x04, 0x08, 0xF2, 0x13, 0x09, 0x24, 0xE4, 0x09, 0x10, 0x02,
  0xC0, 0x00, 0xC0, 0x00,
};


  class infoScreen {
    public:
      infoScreen();
      ~infoScreen();
      void init();
      void update();
      void setBAT(int n);
      void setBLE(bool isEnabled, int n);
      void setAPT(bool isEnabled, int n);
      void setSTA(bool isEnabled, int n);
      void setRSSI(int n);
      void setSNR(int n);
      void setContrast(int n);

    private:
      bool ble_enabled = false; // ble enabled?
      bool apt_enabled = false; // ap enabled?
      bool sta_enabled = false; // sta connection enabled?
      int bat = 0; // battery level
      int ble = 0; // active bt clients
      int apt = 0; // active clients connected to Turpial AP
      int sta = 0; // 0/1 for connection to an WiFi-AP (Internet Gateway)
      int rssi = 0; // LoRa rssi level of the last packet.
      int snr = 0; // LoRa SNR level of the last packet
      int contrast = 255; // 0~255 contrast level.
  };


#endif
